#ifndef __CONNECTOR_H__
#define __CONNECTOR_H__


/***************************************************************************
                          connector.h  -  description
                             -------------------
    begin                : Mon Mar 12 2001
    copyright            : (C) 2001 by Zvika Brakerski, Asaf Koren
    email                : zvika@eng.tau.ac.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


 /*
 This file includes prototypes and definitions of the connector algorithm.
 */

 #include <icq.h>
 #include "protocol.h"
 #include "services.h"
 #include "contactlist.h"

 // Time to wait on select

 #define SELECT_WAIT_SEC 	5
 #define SELECT_WAIT_USEC	0


 // Time to wait between keepalive messages

 #define TIME_BETWEEN_KEEPALIVES_SEC	50

 // Prototypes for functions of the connector application
 void *connector_mod_gen_arg(int accepted_sock, struct sockaddr_in *remote_addr, int sin_size);
 void *connector_mod(void *inp);
 int connector(int s, struct sockaddr_in *remote_addr, int sin_size);

 /*
 Following is a struct which wraps all arguments for the connector
 application.
 */

 typedef struct {
 		int sock;
 		struct sockaddr_in remote_addr;
 		int sin_size;
 } connector_arg;
 	

 /*
 Following is a struct that is used as a link's "environment".
 It contains all things that the link needs to know about in the handler functions.
 */

 typedef struct {
 		ICQLINK link; 		// The link itself
 		int v_contacts;		// Is the contact list valid?
 		clist contacts;		// User's contact list
 		int b_active;			// Is the link active?
// 		int b_alive; 			// Is the connection with the client alive?
 		char *data;				// Additional required data
 		int s_client;			// The socket that is connected to the client
 		int b_halt;				// Do we want to env link activity?
 	} link_env;


#endif	//#ifndef __CONNECTOR_H__
