#ifndef __CONTACTLIST_H__
#define __CONTACTLIST_H__

/***************************************************************************
                          contactlist.h  -  description
                             -------------------
    begin                : Sun Apr 8 2001
    copyright            : (C) 2001 by Zvika Brakerski, Asaf Koren
    email                : zvika@eng.tau.ac.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*
Header file for the contact list implementation.

Note that icqlib implements a contact list mechanism that does not
support saving the name of the contact (only the uin) and therefore
we require an external mechanism for that purpose.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>

// Maximal size for a contact name.
#define MAX_CNAME_SIZE 256

typedef struct contact_entry { // An entry in the contact list
	struct contact_entry *next;
	char *name;
	unsigned long uin;
} centry;

typedef struct { // The contact list itself
	centry *first;
} clist;

// Prototypes for other modules

centry *cl_add(clist *list, char *cname, unsigned long cuin);
centry *cl_find(clist *list, char *cname, unsigned long cuin);
centry *cl_delete(clist *list, char *cname, unsigned long cuin);
void cl_read(clist *list, FILE *in_file);
void cl_write(clist *list, FILE *out_file);
void cl_init(clist *list);
void cl_clean(clist *list);

#endif	//#ifndef __CONTACTLIST_H__
