#ifndef __DB_H__
#define __DB_H__

/***************************************************************************
                          db.h  -  description
                             -------------------
    begin                : Tue Apr 10 2001
    copyright            : (C) 2001 by Zvika Brakerski, Asaf Koren
    email                : zvika@eng.tau.ac.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


 /*
 This file contains prototypes and definitions for the database related issues.
 */

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include "contactlist.h"

// The subdirectory in which the database resides
#define DB_PATH 				".csicq_db/"
// The permissions that the subdirectory should get
#define DB_PERMISSIONS 	0700

// The length of the database path
#define DB_PATH_LEN			(strlen(HOME_DIR)+strlen(DB_PATH))
// An upper bound on the size of a uin
#define UIN_LEN					20

// The extension of files in the database
#define DB_EXT					".cl"
// The length of the extension of files in the database
#define DB_EXT_LEN			3


// Prototypes for functions used by other modules
int initialize_db();
void get_contact_list(unsigned long uin, clist *list);
void put_contact_list(unsigned long uin, clist *list);



#endif	//#ifndef __DB_H__
