/***************************************************************************
                          listener.c  -  description
                             -------------------
    begin                : Sat Mar 10 2001
    copyright            : (C) 2001 by Zvika Brakerski, Asaf Koren
    email                : zvika@eng.tau.ac.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /*
 This file includes the functionality of the listener program.
 */

 #include "listener.h"
 #include "connector.h"

 int listener(listener_options opt)
 {
 		int listening_sock;								// Socket we'll be listening on
 		int accepted_sock;								// Socket for incomming connections
    struct sockaddr_in my_addr;				// A struct to hold local addresses
    struct sockaddr_in remote_addr;		// A struct to hold remote addresses
    int sin_size; 										// An integer to hold size of struct
    pthread_t thread;									// Details of created thread
    int yes=1;

    // Initializing the database
		if (initialize_db())
		{
			perror("mkdir()");
			return -1;
		}
		

    if ((listening_sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
    {
    	perror("socket()");
    	return -1;
    }


    if (setsockopt(listening_sock, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1)
    {
        perror("setsockopt");
        exit(1);
    }


    my_addr.sin_family = AF_INET;
    my_addr.sin_port = htons(CSICQ_PORT);
    my_addr.sin_addr.s_addr = INADDR_ANY;
    memset(&(my_addr.sin_zero), '\0', 8);

    if (bind(listening_sock, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1)
    {
    	perror("bind()");
    	return -1;
    }

    if (listen(listening_sock, BACKLOG) == -1)
    {
    	perror("listen()");
    	close(listening_sock);
    	return -1;
    }


    sin_size = sizeof(struct sockaddr_in);
    while ((accepted_sock = accept(listening_sock, &remote_addr, &sin_size)) != -1)
    {
    	//if (fork() == 0) // This is the child process
    	//	return connector(accepted_sock, remote_addr, sin_size);
    	
    	/* Spawning new thread */
    	
    	pthread_create(&thread, NULL, &connector_mod, connector_mod_gen_arg(accepted_sock, &remote_addr, sin_size));

			// connector_mod(connector_mod_gen_arg(accepted_sock, &remote_addr, sin_size));
    	
    	/* End of creating new thread */
    	
    	sin_size = sizeof(struct sockaddr_in);
    }

    if (accepted_sock == -1)
    {
    	perror("accept()");
    	return -1;
    }

    return 0;
 }
