#ifndef __LISTENER_H__
#define __LISTENER_H__

/***************************************************************************
                          listener.h  -  description
                             -------------------
    begin                : Sat Mar 10 2001
    copyright            : (C) 2001 by Zvika Brakerski, Asaf Koren
    email                : zvika@eng.tau.ac.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /*
 This is the header file for the listener program. This program listens on
 the CSICQ_PORT and awaits for incoming connections. For each such connection
 it forks out a process to take care of it.
 */


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <pthread.h>
#include "db.h"

#define BACKLOG	10

// The port csicq servers listen on
#define CSICQ_PORT 4040

// An enumeration of options for the listener (currently empty)
typedef enum {
	NONE
} listener_options;

// Prototypes for functions used in other modules
int listener(listener_options opt);


#endif	//#ifndef __LISTENER_H__
